/*
 * Read a string of arbitrary length from a
 * given file pointer. LF is accepted as terminator.
 * 1 is returned in case of success, 0 in case of errors.
 * afb 4/2003
 */

#include <stralloc.h>
#include <stdio.h>
#include "sareadline.h"

bool readline(FILE* fp, stralloc* sa) {
   sa->len = 0;
   for(;;) {
      int ch = getc(fp);
      if (ch == EOF) return sa->len > 0;
      if (ch == '\n') break;
      if (!stralloc_readyplus(sa, 1)) return false;
      sa->s[sa->len++] = ch;
   }
   return true;
} // readline
